import java.util.ArrayList;
import java.util.List;
import java.util.Stack;

public class PolandExer {
    public static void main(String[] args) {
        String expression = "1+((2+3)*4)-5";
        List<String> infixExpressionList = toInfixExpression(expression);
        System.out.println(infixExpressionList);
        List<String> result = parseSuffixExpression(infixExpressionList);
        System.out.println(result);
    }

    /**
     * 将中缀表达式转换为对应的List
     * 
     * @param 欲转换的字符串
     * @return 返回List
     */
    public static List<String> toInfixExpression(String s) {
        // 生成一个List，用于存放拆分的内容
        List<String> ls = new ArrayList<String>();
        // 指针，用来充当索引
        int i = 0;
        // 每遍历到一个字符，就放到ls中
        char c;
        // str 用于拼合数字
        String str;
        do {
            // 如果c是一个非数字，则直接加入到ls中
            if ((c = s.charAt(i)) < 48 || (c = s.charAt(i)) > 57) {
                ls.add("" + c);
                i++;
            } else {
                // 如果c是一个数字，需要继续判断是否属于多位数的情况
                str = "";
                // 通过循环，找到完整多位数
                while (i < s.length() && (c = s.charAt(i)) >= 48 && (c = s.charAt(i)) <= 57) {
                    str += c;
                    i++;
                }
                ls.add(str);
            }
        } while (i < s.length());
        return ls;
    }

    public static List<String> parseSuffixExpression(List<String> ls) {
        Stack<String> operStack = new Stack<String>();
        List<String> numStack = new ArrayList<String>();

        // 遍历ls
        for (String item : ls) {
            // 如果是一个数，就直接加到numStack;
            if (item.matches("\\d+")) {
                numStack.add(item);
            } else if (item.equals("(")) {
                operStack.push(item);
            } else if (item.equals(")")) {
                while (!operStack.peek().equals("(")) {
                    numStack.add(operStack.pop());
                }
                operStack.pop();
            } else {
                while (operStack.size()!=0&&Operation.getWeights(item)<=Operation.getWeights(operStack.peek())) {
                    numStack.add(operStack.pop());
                }
                operStack.push(item);
            }
        }
        while (operStack.size()!=0) {
            numStack.add(operStack.pop());
        }
        return numStack;
    }
}

class Operation {
    /**
     * 计算运算符的权重
     * @param operation
     * @return
     */
    public static int getWeights(String operation) {
        // 权重
        int Weights = 0;
        switch (operation) {
            case "+":
                Weights = 1;
                break;
            case "-":
                Weights = 1;
                break;
            case "*":
                Weights = 2;
                break;
            case "/":
                Weights = 1;
                break;
            default:
            //System.out.println("error:运算符不合法！");
            //因为else进行判断，出现其他符合也会出现不合法的提示
                break;
        }
        return Weights;
    }
}